<template>
  <q-toolbar class="bg-primary text-white raised">
    <q-toolbar-title role="heading">Itemtypes
      <q-badge align="top" outline v-if="itemtypes_filtered">
        {{ itemtypes_filtered.length }}
      </q-badge>
    </q-toolbar-title>

    <q-checkbox label="Enum." v-model="enum_only" dense dark title="Toon alleen enumeraties"></q-checkbox>
    &nbsp;<q-icon class="pointer" name="import_export" title="sorteer op naam of op aantal" size="30px"
                  @click="change_sort()"></q-icon>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" autofocus title="Filter itemtypes">
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
        <template v-if="search_value" v-slot:append>
          <q-icon name="cancel" @click.stop.prevent="search_value = ''" class="cursor-pointer"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>

  <q-list bordered class="detail--padding scroll_list">
    <q-item clickable v-ripple
            v-for="(itemtype, index) in itemtypes_filtered"
            v-bind:id="itemtype.name"
            v-bind:key="index"
            active-class="active"
            :dts_name="dts_name"
            :to="{name: 'itemtype_detail',
                    params: {itemtype_name: itemtype.name}}">
      <q-item-section>
        <q-item-label class="full-width">
          {{ itemtype.name }}
          <q-badge class="badge float-right" align="top" outline>{{ itemtype.number_of_concepts }}</q-badge>
        </q-item-label>
      </q-item-section>
    </q-item>
    <q-inner-loading :showing="typeof itemtypes=='undefined'">

      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof itemtypes=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </q-list>

</template>

<script>
import {api} from 'boot/axios'
import _ from 'lodash'

export default {
  name: "ItemtypeList",
  created() {
    this.fetchData()
  },
  data() {
    return {
      itemtypes: undefined,
      search_value: '',
      enum_only: false,
      sort_by: 'name',
      sort_order: 'asc'
    }
  },
  props: {
    dts_name: String,
    nt_version: String,
  },

  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/itemtypes", {
          params: {nt_version: this.nt_version, full: 1},
        })
        .then(response => {
          this.itemtypes = response.data
          if (this.itemtypes.length && this.$route.fullPath.endsWith('itemtypes')) {
            this.$router.push({
              name: 'itemtype_detail',
              replace: true,
              params: {itemtype_name: this.itemtypes_filtered[0].name}
            })
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.itemtypes = ["No results"]
        })
    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    },
    change_sort: function () {
      if (this.sort_by === "name") {
        this.sort_by = "number_of_concepts"
        this.sort_order = "desc"
      } else {
        this.sort_by = "name"
        this.sort_order = "asc"
      }
      this.$nextTick(() => {
        this.scroll_to_active()
      })
    },
  },
  computed: {
    itemtypes_filtered() {
      if (typeof (this.itemtypes) !== 'undefined') {
        let sorted = this.itemtypes
        if (this.enum_only) {
          sorted = sorted.filter(itemtype => itemtype.enumeration !== null)
        }
        if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
          sorted = sorted.filter(itemtype => itemtype.name &&
            itemtype.name.toLowerCase().includes(this.search_value.toLowerCase()))
        }
        return _.orderBy(sorted, this.sort_by, this.sort_order)
      } else {
        return this.itemtypes
      }
    }
  }

}
</script>

<style scoped lang="scss">
.active {
  background: $primary;
  color: white;
  opacity: 0.9;
}

.active .badge {
  color: white;
}

.badge {
  color: $primary;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

.pointer {
  cursor: pointer;
}

</style>
